#ifndef STDLIB_H
#define STDLIB_H

#include <stddef.h>


// Process exit
void exit(int status);
void abort(void);
int atexit(void (*func)(void));

// Memory allocation
void *malloc(size_t size);
void *calloc(size_t nmemb, size_t size);
void *realloc(void *ptr, size_t size);
void *memalign(size_t boundary, size_t size);
void free(void *ptr);

// Numeric functions
int abs(int i);
long labs(long i);
long long llabs(long long i);

// Numeric conversion
int atoi(const char *str);
long strtol(const char *__restrict str, char **__restrict endptr, int base);
long long strtoll(const char *__restrict str, char **__restrict endptr, int base);
unsigned long strtoul(const char *__restrict str,
		char **__restrict endptr, int base);
unsigned long long strtoull(const char *__restrict str,
		char **__restrict endptr, int base);
double strtod(const char *__restrict nptr, char **__restrict endptr);
float strtof(const char *__restrict nptr, char **__restrict endptr);;


void qsort(void *base, size_t nelt, size_t eltsize,
		int (*cmp)(const void *a, const void *b));

#endif	// STDLIB_H
