#ifndef _UNISTD_H_
#define _UNISTD_H_

#include <stdint.h>
#include <sys/types.h>

#define STDIN_FILENO	0
#define STDOUT_FILENO	1
#define STDERR_FILENO	2

#ifndef SEEK_SET
#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2
#endif


// File and directory operations
int unlink(const char *path);
int remove(const char *path);

// File I/O
ssize_t read(int fd, void *buf, size_t size);
ssize_t write(int fd, const void *buf, size_t size);

// File descriptor handling
int dup(int oldfd);
int dup2(int oldfd, int newfd);

void *sbrk(intptr_t increment);

void _exit(int status);

#endif	// _UNISTD_H_
