
#include <unistd.h>

#include <vx/vx.h>
#include <vxsys.h>

extern void end;

static void *brk = &end;

void *sbrk(intptr_t increment)
{
	void *oldbrk = brk;
	intptr_t oldpg = VXPAGEROUND(oldbrk);

	void *newbrk = brk + increment;
	intptr_t newpg = VXPAGEROUND(newbrk);

	if (oldpg < newpg) {

		// Growing the heap
		vxsetperm(oldpg, newpg-oldpg, VXPERM_READ | VXPERM_WRITE);

	} else if (oldpg > newpg) {

		// Shrinking the heap
		vxsetperm(newpg, oldpg-newpg, 0);
	}

	brk = newbrk;
	return oldbrk;
}

