

// Sample inner loop code for release-consistency diff/merge.
//
// On entry:
// 	rdi - original version of page
//	rsi - new version of page to compare against original
//	rdx - page accumulating merged diffs from all branches
//	
//
	.text
	.globl	rcdiff
rcdiff:
	xorl	%eax,%eax
	movdqa	all1s,%xmm6	// error accumulator
1:
	movdqa	(%rdi),%xmm0	// orig block
	movdqa	(%rsi),%xmm1	// new block
	movdqa	(%rdx),%xmm2	// accum block

	movdqa	%xmm0,%xmm3	// form eq-mask for orig & new
	pcmpeqb	%xmm1,%xmm3

	movdqa	%xmm0,%xmm4	// form eq-mask for orig & accum
	pcmpeqb	%xmm2,%xmm4

	movdqa	%xmm3,%xmm5	// check for collisions (not-eq in both)
	por	%xmm4,%xmm5
	pand	%xmm5,%xmm6

	pand	%xmm3,%xmm2	// merge new block into accum
	pandn	%xmm1,%xmm3
	por	%xmm3,%xmm2
	movdqa	%xmm2,(%rdx)

	addq	$16,%rdi	// move to next block
	addq	$16,%rsi
	addq	$16,%rdx

	decb	%al
	jnz	1b

	pmovmskb %xmm6,%eax	// form error return code
	xorl	$0xffff,%eax
	ret


// (unrolled version of same)
	.text
	.globl	rcdiffu
rcdiffu:
	movl	$128,%eax	// count
	movdqa	all1s,%xmm6	// error accumulator
1:
	movdqa	(%rdi),%xmm0	// orig block
	movdqa	(%rsi),%xmm1	// new block
	movdqa	(%rdx),%xmm2	// accum block

	movdqa	16(%rdi),%xmm8	// orig block
	movdqa	16(%rsi),%xmm9	// new block
	movdqa	16(%rdx),%xmm10	// accum block


	movdqa	%xmm0,%xmm3	// form eq-mask for orig & new
	pcmpeqb	%xmm1,%xmm3

	movdqa	%xmm0,%xmm4	// form eq-mask for orig & accum
	pcmpeqb	%xmm2,%xmm4

	movdqa	%xmm3,%xmm5	// check for collisions (not-eq in both)
	por	%xmm4,%xmm5
	pand	%xmm5,%xmm6

	pand	%xmm3,%xmm2	// merge new block into accum
	pandn	%xmm1,%xmm3
	por	%xmm3,%xmm2
	movdqa	%xmm2,(%rdx)

	movdqa	%xmm8,%xmm11	// form eq-mask for orig & new
	pcmpeqb	%xmm9,%xmm11

	movdqa	%xmm8,%xmm12	// form eq-mask for orig & accum
	pcmpeqb	%xmm10,%xmm12

	movdqa	%xmm11,%xmm13	// check for collisions (not-eq in both)
	por	%xmm12,%xmm13
	pand	%xmm13,%xmm6

	pand	%xmm11,%xmm10	// merge new block into accum
	pandn	%xmm9,%xmm11
	por	%xmm11,%xmm10
	movdqa	%xmm10,16(%rdx)


	addq	$32,%rdi	// move to next block
	addq	$32,%rsi
	addq	$32,%rdx

	decb	%al
	jnz	1b

	pmovmskb %xmm6,%eax	// form error return code
	xorl	$0xffff,%eax
	ret


	.data
	.p2align 4
all1s:
	.quad	~0, ~0

