

	.text

// edi: starting checksum
// rsi: pointer to 16-byte-aligned buffer
// rdx: number of 16-byte blocks to checksum
	.globl	xmmcsum
xmmcsum:
	movdqa	bmsk,%xmm8	// xmm8: low-byte-per-word mask 
	movdqa	mul0,%xmm9
	movdqa	mul1,%xmm10
	movdqa	wmsk,%xmm11

	movl	%edi,%eax
	andl	$0xffff,%edi
	shrl	$16,%eax
	movd	%edi,%xmm4	// xmm4: accumulator for A-parts of checksum
	movd	%eax,%xmm5	// xmm5: accumulator for B-parts

1:
	movdqa	(%rsi),%xmm0	// xmm0: next 16-byte block of data
	addl	$16,%esi

	movdqa	%xmm0,%xmm1
	pand	%xmm8,%xmm0	// xmm0: bytes 0, 2, 4, ..., 14
	psrlw	$8,%xmm1	// xmm1: bytes 1, 3, 5, ..., 15

	// A-part of checksum
	movdqa	%xmm0,%xmm2	// add bytes together
	paddw	%xmm1,%xmm2
	movdqa	%xmm2,%xmm3	// split out words into 32-bit ints
	pand	%xmm11,%xmm2
	psrld	$16,%xmm3
	movdqa	%xmm4,%xmm6	// save old A-parts
	paddd	%xmm2,%xmm4	// accumulate new A-parts
	paddd	%xmm3,%xmm4

	// B-part of checksum
	pmaddwd	%xmm9,%xmm0	// scale the bytes and add pairs forming ints
	pmaddwd	%xmm10,%xmm1
	paddd	%xmm1,%xmm0	// add corresponding 32-bit ints
	pslld	$4,%xmm6	// scale old A-parts by 16
	paddd	%xmm0,%xmm5	// accumulate new scaled bytes
	paddd	%xmm6,%xmm5	// accumulate old scaled A-parts

	decq	%rdx
	jnz	1b

	movdqa	%xmm4,%xmm0	// Combine the four parts of each accumulator
	movdqa	%xmm5,%xmm1
	psrldq	$8,%xmm0
	psrldq	$8,%xmm1
	paddq	%xmm0,%xmm4
	paddq	%xmm1,%xmm5
	movdqa	%xmm4,%xmm0
	movdqa	%xmm5,%xmm1
	psrldq	$4,%xmm0
	psrldq	$4,%xmm1
	paddq	%xmm0,%xmm4
	paddq	%xmm1,%xmm5

	movd	%xmm4,%eax	// A-part of final checksum
	xorl	%edx,%edx
	movl	$65521,%ecx
	divl	%ecx
	movl	%edx,%esi

	movd	%xmm5,%eax	// B-part of final checksum
	xorl	%edx,%edx
	divl	%ecx

	movl	%edx,%eax	// combine them to produce return value
	shll	$16,%eax
	orl	%esi,%eax
	retq


	.data
	.p2align 4

bmsk:	.word	0x00ff,0x00ff,0x00ff,0x00ff,0x00ff,0x00ff,0x00ff,0x00ff
mul0:	.word	15,13,11,9,7,5,3,1
mul1:	.word	16,14,12,10,8,6,4,2
wmsk:	.long	0x0000ffff,0x0000ffff,0x0000ffff,0x0000ffff

